///--------------------------------------------------------------------
// ohlc.mq4 
// The code should be used for educational purpose only.
//--------------------------------------------------------------------
#property indicator_chart_window    // Indicator is drawn in the main window
#property indicator_buffers 6       // Number of buffers
#property indicator_color1 White     // Color of the 1st line
#property indicator_color2 NULL      // Color of the 2nd line
#property indicator_color3 Blue     // Color of the 1st line
#property indicator_color4 Red      // Color of the 2nd line
#property indicator_color5 NULL     // Color of the 1st line
#property indicator_color6 Pink      // Color of the 2nd line

extern string ParameterUsedInternally = "";
extern int tf      =1440;
extern int barBack = 1;
 
double Buf_H[];
double Buf_L[];
double Buf_HHV[];
double Buf_LLV[];
double Buf_open[];
double Buf_close[];             // Declaring arrays (for indicator buffers)
bool   gettingBars;
string indicatorSavedFileName;
//--------------------------------------------------------------------
int init()                          // Special function init()
  {
   SetIndexBuffer(0,Buf_H); 
   SetIndexBuffer(1,Buf_L);     SetIndexStyle (1,DRAW_NONE,0);// Line st
   SetIndexBuffer(2,Buf_HHV);
   SetIndexBuffer(3,Buf_LLV);
   SetIndexBuffer(4,Buf_open);  SetIndexStyle (4,DRAW_NONE,0);// Line st
   SetIndexBuffer(5,Buf_close); SetIndexStyle (5,DRAW_NONE,0);// Line st
   
   SetIndexLabel(0,"prewopen");
   SetIndexLabel(1,"b");
   SetIndexLabel(2,"prewhigh");
   SetIndexLabel(3,"prewlow");
   SetIndexLabel(4,"e");
   SetIndexLabel(5,"close");
   
   indicatorSavedFileName=WindowExpertName();
   gettingBars = (ParameterUsedInternally=="return changed bars number");
   
   return;                          // Exit the special funct. init()
   
   
   
   
  }
//--------------------------------------------------------------------
int start()                         // Special function start()
  {
   int i,                           // Bar index
       Counted_bars;                // Number of counted bars
//--------------------------------------------------------------------
   Counted_bars=IndicatorCounted();      // Number of counted bars
   i=MathMin(Bars-Counted_bars,Bars-1);  // Index of the first uncounted
      if (gettingBars) { Buf_H[0] = i+1; return(0); }
      if (tf<Period()) return(-1);
      if (tf>Period())
         i = MathMax(i,MathMin(Bars,iCustom(NULL,tf,indicatorSavedFileName,"return changed bars number",0,0)*tf/Period()));
   while(i>=0)                           // Loop for uncounted bars
   {
     int y=iBarShift(NULL,tf,Time[i]);
    //double oHV=iOpen(NULL,tf,0)+br*Point;
    //double oLV=iOpen(NULL,tf,0)-br*Point;
    
      Buf_H[i]= iOpen(NULL,tf,y+barBack);     // Value of 0 buffer on i bar
      Buf_L[i]= iOpen(NULL,tf,y+barBack);
      
      Buf_HHV[i] = iHigh(NULL,tf,y+barBack);
      Buf_LLV[i] = iLow(NULL,tf,y+barBack);
      Buf_open[i]= iOpen(NULL,1440,y+barBack);
      Buf_close[i]= iClose(NULL,1440,y+barBack);
      
      
      
      
     
                   // Value of 1st buffer on i bar
      i--;                          // Calculating index of the next bar
     }
//--------------------------------------------------------------------
   return;                          // Exit the special funct. start()
  }
//--------------------------------------------------------------------